"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NodePath = void 0;
var react_1 = __importDefault(require("react"));
var antd_1 = require("antd");
var react_2 = require("@designable/react");
var react_3 = require("@formily/react");
require("./styles.less");
exports.NodePath = react_3.observer(function () {
    var selected = react_2.useCurrentNode();
    var selection = react_2.useSelection();
    var hover = react_2.useHover();
    var prefix = react_2.usePrefix('node-path');
    if (!selected)
        return react_1.default.createElement(react_1.default.Fragment, null);
    var nodes = selected.getParents().slice(0, 2).reverse().concat(selected);
    return (react_1.default.createElement(antd_1.Breadcrumb, { className: prefix }, nodes.map(function (node, key) {
        return (react_1.default.createElement(antd_1.Breadcrumb.Item, { key: key },
            key === 0 && (react_1.default.createElement(react_2.IconWidget, { infer: "Position", style: { marginRight: 3 } })),
            react_1.default.createElement("a", { href: "", onMouseEnter: function () {
                    hover.setHover(node);
                }, onClick: function (e) {
                    e.stopPropagation();
                    e.preventDefault();
                    selection.select(node);
                } },
                react_1.default.createElement(react_2.TextWidget, null, node.designerProps.title))));
    })));
});
