"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useLocales = void 0;
var react_1 = __importDefault(require("react"));
var core_1 = require("@formily/core");
var core_2 = require("@designable/core");
var shared_1 = require("@designable/shared");
var react_2 = require("@designable/react");
var takeLocales = function (token) {
    var message = core_2.GlobalRegistry.getDesignerMessage(token);
    if (shared_1.isStr(message))
        return {
            title: message,
        };
    if (shared_1.isPlainObj(message))
        return message;
    return {};
};
var takeIcon = function (message) {
    if (!shared_1.isStr(message))
        return;
    var matched = message.match(/@([^:\s]+)(?:\s*\:\s*([\s\S]+))?/);
    if (matched)
        return [matched[1], matched[2]];
    return;
};
var useLocales = function () {
    core_1.onFieldReact('*', function (field) {
        var _a, _b;
        var token = field.path.toString().replace(/\.[\d+]/g, '');
        var locales = takeLocales("settings." + token);
        if (locales.title) {
            field.title = locales.title;
        }
        if (locales.description) {
            field.description = locales.description;
        }
        if (locales.tooltip) {
            field.decorator[1] = field.decorator[1] || [];
            field.decorator[1].tooltip = locales.tooltip;
        }
        if (locales.placeholder) {
            field.component[1] = field.component[1] || [];
            field.component[1].placeholder = locales.placeholder;
        }
        if (!core_1.isVoidField(field)) {
            if (((_a = locales.dataSource) === null || _a === void 0 ? void 0 : _a.length) && ((_b = field.dataSource) === null || _b === void 0 ? void 0 : _b.length)) {
                field.dataSource = field.dataSource.map(function (item, index) {
                    var label = locales.dataSource[index] ||
                        locales.dataSource[item.value] ||
                        item.label;
                    var icon = takeIcon(label);
                    return __assign(__assign({}, item), { label: icon ? (react_1.default.createElement(react_2.IconWidget, { infer: icon[0], tooltip: icon[1] })) : (label) });
                });
            }
        }
    });
};
exports.useLocales = useLocales;
